> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Multiple Metafields

POST https://api.bigcommerce.com/stores/{store_hash}/v3/orders/metafields
Content-Type: application/json

Create multiple metafields.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/order-operations/batch-metafields/create-orders-metafields

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Order Transactions | read and modify `transactions` and `payment_methods` | `store_v2_transactions` | | Order Transactions | read `transactions` and `payment_methods` | `store_v2_transactions_read_only` | | Orders | read and modify `payment_methods` |`store_v2_orders`| | Orders | read `payment_methods` |`store_v2_orders_read_only`| ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Body (application/json)

This endpoint expects a list of OrdersMetafieldsPostRequestBodyContentApplicationJsonSchemaItems.

- `list of OrdersMetafieldsPostRequestBodyContentApplicationJsonSchemaItems`

## Response

### 200

List of created `Metafield` objects.

- `data` (list of Metafield, optional)
- `errors` (list of any, optional) — Empty for 200 responses.
- `meta` (BatchOperationMeta, optional)

## Errors

### 400 Bad Request Error

Bad Request. Input is invalid.

- `status` (double, optional)
- `title` (string, optional)
- `type` (string, optional)
- `detail` (string, optional)

### 422 Unprocessable Entity Error

Response object for metafields creation with partial success.

- `data` (list of Metafield, optional)
- `errors` (list of Error, optional)
- `meta` (WriteCollectionPartialSuccessMeta, optional) — Additional data about the response.

## Types

### OrdersMetafieldsPostRequestBodyContentApplicationJsonSchemaItems

Common Metafield properties.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. |Value|Description | |:-|:-| |`app_only`|Private to the app that owns the field| |`read`|Visible to other API consumers| |`write`|Open for reading and writing by other API consumers| |`read_and_sf_access`|Visible to other API consumers, including on storefront| |`write_and_sf_access`|Open for reading and writing by other API consumers, including on storefront|
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes.
- `key` (string, required) — The name of the field, for example: `location_id`, `color`.
- `value` (string, required) — The value of the field, for example: `1`, `blue`.
- `resource_id` (integer, required) — The ID for the order with which the metafield is associated.
- `description` (string, optional) — Description for the metafields.

### Metafield

Allows app partners to write custom data to various resources in the API.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. |Value|Description | |:-|:-| |`app_only`|Private to the app that owns the field| |`read`|Visible to other API consumers| |`write`|Open for reading and writing by other API consumers| |`read_and_sf_access`|Visible to other API consumers, including on storefront| |`write_and_sf_access`|Open for reading and writing by other API consumers, including on storefront|
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `date_created` (datetime, optional) — Date and time of the metafieldʼs creation.
- `date_modified` (datetime, optional) — Date and time when the metafield was last updated.
- `description` (string, optional) — Description for the metafields.
- `id` (integer, optional) — The unique identifier for the metafields.
- `key` (string, optional) — The name of the field, for example: `location_id`, `color`.
- `namespace` (string, optional) — Namespace for the metafield, for organizational purposes.
- `owner_client_id` (string, optional) — Client ID for the metafieldʼs creator.
- `resource_id` (integer, optional) — The unique identifier for the resource with which the metafield is associated.
- `resource_type` (enum, optional) — The type of resource with which the metafield is associated.
  - Allowed values: `order`, `brand`, `product`, `variant`, `category`
- `value` (string, optional) — The value of the field, for example: `1`, `blue`.

### BatchOperationMeta

- `total` (integer, optional) — The total number of operations in the batch.
- `success` (integer, optional) — The number of failed operations in the batch.
- `failed` (integer, optional) — The number of failed operations in the batch.

### Error

Error response payload for the BigCommerce API.

- `status` (integer, optional) — The HTTP status code for the error.
- `title` (string, optional) — The error title.
- `type` (string, optional) — The error type.
- `errors` (ErrorDetail, optional) — Error detail response payload for the BigCommerce API.

### WriteCollectionPartialSuccessMeta

Additional data about the response.

- `total` (integer, optional) — Total number of items in the result set.
- `success` (integer, optional) — Total number of items that were successfully deleted.
- `failed` (integer, optional) — Total number of items that failed to be deleted.

### ErrorDetail

Error detail response payload for the BigCommerce API.

## Examples

**Request**

```json
[
  {
    "permission_set": "app_only",
    "namespace": "Sales Department",
    "key": "Staff Name",
    "value": "Ronaldo",
    "resource_id": 42
  }
]
```

**Response**

```json
{
  "data": [
    {
      "permission_set": "app_only",
      "date_created": "2022-06-16T18:39:00+00:00",
      "date_modified": "2022-06-16T18:39:00+00:00",
      "description": "order",
      "id": 1,
      "key": "Staff Name",
      "namespace": "Sales Department",
      "owner_client_id": "asdfasdfasdfasdfasdfasdfasdf",
      "resource_id": 0,
      "resource_type": "order",
      "value": "Ronaldo"
    }
  ],
  "errors": [],
  "meta": {
    "total": 1,
    "success": 1,
    "failed": 1
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields"

payload = [
    {
        "permission_set": "app_only",
        "namespace": "Sales Department",
        "key": "Staff Name",
        "value": "Ronaldo",
        "resource_id": 42
    }
]
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields';
const options = {
  method: 'POST',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '[{"permission_set":"app_only","namespace":"Sales Department","key":"Staff Name","value":"Ronaldo","resource_id":42}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields"

	payload := strings.NewReader("[\n  {\n    \"permission_set\": \"app_only\",\n    \"namespace\": \"Sales Department\",\n    \"key\": \"Staff Name\",\n    \"value\": \"Ronaldo\",\n    \"resource_id\": 42\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"permission_set\": \"app_only\",\n    \"namespace\": \"Sales Department\",\n    \"key\": \"Staff Name\",\n    \"value\": \"Ronaldo\",\n    \"resource_id\": 42\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"permission_set\": \"app_only\",\n    \"namespace\": \"Sales Department\",\n    \"key\": \"Staff Name\",\n    \"value\": \"Ronaldo\",\n    \"resource_id\": 42\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields', [
  'body' => '[
  {
    "permission_set": "app_only",
    "namespace": "Sales Department",
    "key": "Staff Name",
    "value": "Ronaldo",
    "resource_id": 42
  }
]',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"permission_set\": \"app_only\",\n    \"namespace\": \"Sales Department\",\n    \"key\": \"Staff Name\",\n    \"value\": \"Ronaldo\",\n    \"resource_id\": 42\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "permission_set": "app_only",
    "namespace": "Sales Department",
    "key": "Staff Name",
    "value": "Ronaldo",
    "resource_id": 42
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/orders/metafields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```